/**
 **	File:	sql2class.cpp
 **
 **	Published / author: 2004-04-14 / grymse@alhem.net
 **/

/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#include "sql2class.h"
#include "utils.h"
#include "gclass.h"
#include "gclasslib.h"
#include "Parse.h"
#include "list.h"

#include <mysql/mysql.h>


	TBLS *tblsbase = NULL;
	char namespc[40];
	char baseclass[40];
	short container = 0;
	bool mediumtext = false;
	bool use_stl = false;
	

short inset(char *s,char *set)
{
	Parse *pa = new Parse(set);
	char slask[200];
	short r = 0;

	pa -> getword(slask);
	while (*slask && !r)
	{
		if (!strncasecmp(s,slask,strlen(slask)))
			r++;
		pa -> getword(slask);
	}
	delete pa;
	return r;
}

FIELDS *reg_column(TBLS *table,char *name,char *typ)
{
	FIELDS *t;
	short l;	// type name length
	char len[200];

	strlwr(name);

//	printf("%s.%s %s\n",table,name,typ);

	t = new FIELDS;
	t -> num = listlen(table -> fieldsbase);
	strcpy(t -> column,name);
	strcpy(t -> typ,typ);
	t -> length = 0;
	*t -> comment = 0;
	t -> ignore = false; // wont use field in insert/update if true


// status enum('gift','sambo','singel') not null,

	if (!strncasecmp(typ,"decimal",7) || !strncasecmp(typ,"float",5))
	{
		strcpy(t -> ctype,"double");
	} else
	if (!strncasecmp(typ,"enum",4))
	{
		t -> length = strlen(typ);
		sprintf(t -> ctype,"char[%d]",t -> length);
	} else
	if (!strncasecmp(typ,"set",4))
	{
		t -> length = strlen(typ);
		sprintf(t -> ctype,"char[%d]",t -> length);
	} else
	if ((l = inset(typ,"tinyint smallint mediumint int integer")) != 0)
		strcpy(t -> ctype,"long");
	else
	if (!strncasecmp(typ,"bigint",6))
	{
// long long?

	} else
	if (!strncasecmp(typ,"char",4))
	{
		strcpy(len,typ + 5);
		len[strlen(len) - 1] = 0;
		t -> length = atoi(len);
//		printf("%s length %d\n",typ,t -> length);
		sprintf(t -> ctype,"char[%d]",t -> length + 1);
	} else
	if (!strncasecmp(typ,"varchar",7))
	{
		strcpy(len,typ + 8);
		len[strlen(len) - 1] = 0;
		t -> length = atoi(len);
//		printf("%s length %d\n",typ,t -> length);
		sprintf(t -> ctype,"char[%d]",t -> length + 1);
	} else
	if (!strcasecmp(typ,"datetime") || !strcasecmp(typ,"date") || !strcasecmp(typ,"time") ||
		!strncasecmp(typ,"timestamp",9)
		)
	{
		strcpy(t -> ctype,"char[40]");
		t -> length = 40;
	} else
	if (!strncasecmp(typ,"year",4))
	{
		strcpy(t -> ctype,"long");
	} else
	if (!strcasecmp(typ,"text"))
	{
		strcpy(t -> ctype,"text");
		t -> length = -1;
	} else
	if (!strcasecmp(typ,"mediumtext"))
	{
		strcpy(t -> ctype,"mediumtext");
		t -> length = -1;
		t -> ignore = true;
		mediumtext = true;
	} else
	{
		printf("Unsupported column data type: %s.%s '%s'\n",table -> name,name,typ);
		*t -> ctype = 0;
		t -> length = 0;
		t -> ignore = true; // seems like a good idea
	}
	addlist(&table -> fieldsbase,t);
	return t;
}


/*
 *
 */

int main(int argc,char *argv[])
{
	FILE *fil;
	TBLS *table = NULL;
	FIELDS *current = NULL;
	Parse *pa;
	int loop;
	short state = 0;
	short makerel = 0;
	short overwrite = 0;
	short global = 0;
	short build = 0;
	char slask[200];
	char current_column[200];
	char filename[200];
	char dbname[200];
	char includedir[200];
	char comment[200];
	char libname[200];
	char prefix[200];

	strcpy(prefix,"/usr/devel");
	*filename = 0;
	*libname = 0;
	*dbname = 0;
	*namespc = 0;
	*baseclass = 0;

	for (loop = 1; loop < argc; loop++)
		if (!strcmp(argv[loop],"-container"))
			container++;
		else
		if (!strcmp(argv[loop],"-makerel"))
			makerel++;
		else
		if (!strcmp(argv[loop],"-overwrite"))
			overwrite++;
		else
		if (!strcmp(argv[loop],"-prefix") && loop < argc - 1)
		{
			loop++;
			strcpy(prefix,argv[loop]);
			if (prefix[strlen(prefix) - 1] == '/')
				prefix[strlen(prefix) - 1] = 0;
		} else
		if (!strcmp(argv[loop],"-database") && loop < argc - 1)
		{
			loop++;
			strcpy(dbname,argv[loop]);
			strlwr(dbname);
			*dbname -= 32;
		} else
		if (!strcmp(argv[loop],"-global"))
			global++;
		else
		if (*argv[loop] != '-')
			strcpy(filename,argv[loop]);
		else
		if (!strcmp(argv[loop],"-lib") && loop < argc - 1)
		{
			loop++;
			strcpy(libname,argv[loop]);
		} else
		if (!strcmp(argv[loop],"-build"))
			build++;
		else
		if (!strcmp(argv[loop],"-namespace") && loop < argc - 1)
		{
			loop++;
			strcpy(namespc,argv[loop]);
		}
		else
		if (!strcmp(argv[loop],"-baseclass") && loop < argc - 1)
		{
			loop++;
			strcpy(baseclass,argv[loop]);
		}
		else
		if (!strcmp(argv[loop],"-stl"))
		{
			use_stl = true;
		}
		else
		{
			printf("Unknown option '%s'...\n",argv[loop]);
		}
	sprintf(includedir,"%s/include",prefix);

	if (argc < 2)
	{
		printf("Usage: %s <.sql file> [options]\n",*argv);
		printf(" options:\n");
		printf("  -overwrite	existing files are overwritten\n");
//		printf("  -makerel	make relation class for three input tables\n");
//		printf("		 (tbl1-1, tbl2-n, tbl3-link table)\n");
		printf("  -database <name>enter database name in generated file names\n");
		printf("		 (sql<Databasename>Tbl<table>.h)\n");
		printf("  -global	generate .h files to global include directory\n");
		printf("		 (default /usr/devel/include/)\n");
		printf("  -prefix <path>set global directory (default '/usr/devel')\n");
		printf("  -lib <name>	generate class library\n");
		printf("  -build	build lib if '-global' and '-lib' is used\n");
		printf("  -namespace <name> use namespace\n");
		printf("  -baseclass <name> generated classes inherits from...\n");
		printf("  -container	generate old style container class also\n");
		printf("  -stl          use std::string in generated classes\n");
		exit(-1);
	}
	if (!*filename)
		fil = stdin;
	else
		if ((fil = fopen(filename,"rt")) == NULL)
		{
			printf("%s: Couldn't open '%s'...\n",*argv,argv[1]);
			exit(-1);
		}


// read tables

	fgets(slask,200,fil);
	while (!feof(fil))
	{
		slask[strlen(slask) - 1] = 0;
		pa = new Parse(slask);
		pa -> setbreak(',');
		pa -> disablebreak('(');
		pa -> enablebreak(')');
		pa -> getword(slask);
		while (*slask)
		{
			switch (state)
			{
			case 0:		// wait for 'create'
				if (!strcasecmp(slask,"create"))
					state = 1;
				break;
			case 1:		// wait for 'table'
				if (!strcasecmp(slask,"table"))
					state = 2;
				else
				{
					current = NULL;
					state = 0;
				}
				break;
			case 2:		// get table name
				table = new TBLS;
				strcpy(table -> name,slask);
				table -> fieldsbase = NULL;
				addlist(&tblsbase,table);

				state = 3;
				break;
			case 3:		// get '('
				if (!strcmp(slask,"("))
					state = 4;
				else
				{
					current = NULL;
					state = 0;
				}
				break;
			case 4:		// get column name or ')' end of table
				if (!strncmp(slask,"/*",2))
				{
					*comment = 0;
					state = 7;
				} else
				if (!strcasecmp(slask,"primary") ||
				    !strcasecmp(slask,"key") ||
				    !strcasecmp(slask,"unique") ||
				    !strcasecmp(slask,"index"))
				{
				// TODO: use index to build queries?
					while (*slask)
						pa -> getword(slask);
				} else
				if (*slask == ')' || !strcmp(slask,");"))
				{
					current = NULL;
					state = 0;
				} else
				{
					strcpy(current_column,slask);
					state = 5;
				}
				break;
			case 5:		// get column type
				current = reg_column(table,current_column,slask);
				state = 6;
				break;
			case 6:		// wait for ',' or ')'
				if (*slask == ',')
					state = 4;
				else
				if (*slask == ')')
				{
					current = NULL;
					state = 0;
				}
				break;
			case 7:
				while (strcmp(slask + strlen(slask) - 2,"*/"))
				{
					if (*comment)
						strcat(comment," ");
					strcat(comment,slask);
					pa -> getword(slask);
				}
//				printf("comment: '%s'<br>\n",comment);
				if (current)
					strcpy(current -> comment,comment);
				state = 4;
				break;
			}
			pa -> getword(slask);
		}
		delete pa;
		fgets(slask,200,fil);
	}
	fclose(fil);


// generate source

	if (makerel)
	{
		if (listlen(tblsbase) != 3)
		{
			fprintf(stderr,"You need exactly three tables to generate this.\n");
			exit(-1);
		}
		// tbl3: [num] [ptrtbl1] [ptrtbl2] [valuex] [valuey] [charz]

//		makerelclass(tblsbase,dbname);
	} else
	if (*libname)
	{
		generate_lib(overwrite,dbname,global,includedir,libname,prefix);
		if (build && global)
		{
			sprintf(slask,"%s/src/%s",prefix,libname);
			if (!chdir(slask))
				system("make install");
			else
				printf("chdir('%s') failed\n",slask);
		}
	} else
		for (table = tblsbase; table; table = table -> next)
			generate_class(table,overwrite,dbname,global,includedir);

}

